#include "../shared/shared.h"
#include <stdio.h>
#include <string.h>
#include <math.h> 
#include <time.h>
#include <iostream>

#include "Mesh2.h"
#include "QuadTree.h"
#include "SetOfE4.h"

using namespace std; 
namespace bamg {

	int  Triangles::counter = 0;
	Triangles* CurrentTh=0;
	int hinterpole=1;
	int  ForDebugging = 0;
	const Direction NoDirOfSearch = Direction();

	Int4 AGoodNumberPrimeWith(Int4 n){
		const Int4 BigPrimeNumber[] ={ 567890359L,
			567890431L,  567890437L,  567890461L,  567890471L,
			567890483L,  567890489L,  567890497L,  567890507L,
			567890591L,  567890599L,  567890621L,  567890629L , 0};

		Int4 o = 0;
		Int4 pi = BigPrimeNumber[1];
		for (int i=0; BigPrimeNumber[i]; i++) {
			Int4 r = BigPrimeNumber[i] % n;
			Int4 oo = Min(Min(r,n-r),Min(Abs(n-2*r),Abs(n-3*r)));
			if ( o < oo) 
				o=oo,pi=BigPrimeNumber[i];}
			//  cout << " AGoodNumberPrimeWith " << n << " " <<pi << " "<< o << endl;
			return pi; 
	}

	void MeshError(int Err,Triangles *Th){ 
		cerr << " Fatal error in the meshgenerator " << Err << endl ;
		exit(1); 
	}

	ostream& operator <<(ostream& f, const  Triangle & ta) {
		if(CurrentTh)
			f << "[" << CurrentTh->Number(ta) << "::" 
				<<  CurrentTh->Number(ta.ns[0]) << "," 
				<<  CurrentTh->Number(ta.ns[1]) << "," 
				<<  CurrentTh->Number(ta.ns[2]) << "," 
				<< "{" <<  CurrentTh->Number(ta.at[0]) << " " << ta.aa[0] << "} " 
				<< "{" <<  CurrentTh->Number(ta.at[1]) << " " << ta.aa[1] << "} " 
				<< "{" <<  CurrentTh->Number(ta.at[2]) << " " << ta.aa[2] << "} " 
				<< "]" ;
		else
			f << "[" 
				<< ta.ns[0] << "," 
				<< ta.ns[1] << "," 
				<< ta.ns[2] << "," 
				<< "{" << ta.at[0] << " " << ta.aa[0] << "} " 
				<< "{" << ta.at[1] << " " << ta.aa[1] << "} " 
				<< "{" << ta.at[2] << " " << ta.aa[2] << "} " 
				<< "]" ;
		return f;}


		int SwapForForcingEdge(Vertex   *  & pva ,Vertex  * &   pvb ,
				TriangleAdjacent & tt1,Icoor2 & dets1, Icoor2 & detsa,Icoor2 & detsb, int & NbSwap)
		{ // l'arete ta coupe l'arete pva pvb
			// de cas apres le swap sa coupe toujours
			// on cherche l'arete suivante 
			// on suppose que detsa >0 et detsb <0
			// attention la routine echange pva et pvb 

			if(tt1.Locked()) return 0; // frontiere croise 

			TriangleAdjacent tt2 = Adj(tt1);
			Triangle *t1=tt1,*t2=tt2;// les 2 triangles adjacent
			Int1 a1=tt1,a2=tt2;// les 2 numero de l arete dans les 2 triangles
			assert ( a1 >= 0 && a1 < 3 );

			Vertex & sa= (* t1)[VerticesOfTriangularEdge[a1][0]];
			Vertex & s1= (*t1)[OppositeVertex[a1]];
			Vertex & s2= (*t2)[OppositeVertex[a2]];


			Icoor2 dets2 = det(*pva,*pvb,s2);
			Icoor2 det1=t1->det , det2=t2->det ;
			Icoor2 detT = det1+det2;
			assert((det1>0 ) && (det2 > 0));
			assert ( (detsa < 0) && (detsb >0) ); // [a,b] cut infinite line va,bb
			Icoor2 ndet1 = bamg::det(s1,sa,s2);
			Icoor2 ndet2 = detT - ndet1;

			int ToSwap =0; //pas de swap
			if ((ndet1 >0) && (ndet2 >0)) 
			{ // on peut swaper  
				if ((dets1 <=0 && dets2 <=0) || (dets2 >=0 && detsb >=0))
					ToSwap =1; 
				else // swap alleatoire 
					if (BinaryRand()) 
						ToSwap =2; 
			}
			if (ToSwap) NbSwap++,
				bamg::swap(t1,a1,t2,a2,&s1,&s2,ndet1,ndet2);

			int ret=1;

			if (dets2 < 0) {// haut
				dets1 = ToSwap ? dets1 : detsa ;
				detsa = dets2; 
				tt1 =  Previous(tt2) ;}
			else if (dets2 > 0){// bas 
				dets1 = ToSwap ? dets1 : detsb ;
				detsb = dets2;
				//xxxx tt1 = ToSwap ? tt1 : Next(tt2);
				if(!ToSwap) tt1 =  Next(tt2);
			}
			else { // changement de sens 
				if (ForDebugging)  cout << "changement de sens" << endl;
				ret = -1;
				Exchange(pva,pvb);
				Exchange(detsa,detsb);
				Exchange(dets1,dets2);
				Exchange(tt1,tt2);
				dets1=-dets1;
				dets2=-dets2;
				detsa=-detsa;
				detsb=-detsb;

				if (ToSwap) 
					if (dets2 < 0) {// haut
						dets1 = (ToSwap ? dets1 : detsa) ;
						detsa = dets2; 
						tt1 =  Previous(tt2) ;}
					else if (dets2 > 0){// bas 
						dets1 = (ToSwap ? dets1 : detsb) ;
						detsb =  dets2;
						if(!ToSwap) tt1 =  Next(tt2);
					}
					else {// on a fin ???
						tt1 = Next(tt2);
						ret =0;}

			}
			return ret;
		}

		int ForceEdge(Vertex &a, Vertex & b,TriangleAdjacent & taret)  
		{ 
			int NbSwap =0;
			assert(a.t && b.t); // the 2 vertex is in a mesh 
			int k=0;
			taret=TriangleAdjacent(0,0); // erreur 

			TriangleAdjacent tta(a.t,EdgesVertexTriangle[a.vint][0]);
			Vertex   *v1, *v2 = tta.EdgeVertex(0),*vbegin =v2;
			// we turn around a in the  direct sens  

			Icoor2 det2 = v2 ? det(*v2,a,b): -1 , det1;
			if(v2) // normal case 
				det2 = det(*v2,a,b);
			else { // no chance infini vertex try the next
				tta= Previous(Adj(tta));
				v2 = tta.EdgeVertex(0);
				vbegin =v2;
				assert(v2);
				det2 = det(*v2,a,b);
				//   cout << " No Change try the next" << endl;
			}

			while (v2 != &b) {
				TriangleAdjacent tc = Previous(Adj(tta));    
				v1 = v2; 
				v2 = tc.EdgeVertex(0);
				det1 = det2;
				det2 =  v2 ? det(*v2,a,b): det2; 

				if((det1 < 0) && (det2 >0)) { 
					// try to force the edge 
					Vertex * va = &a, *vb = &b;
					tc = Previous(tc);
					assert ( v1 && v2);
					Icoor2 detss = 0,l=0,ks;
					// cout << "Real ForcingEdge " << *va << *vb << detss << endl;
					while ((ks=SwapForForcingEdge(  va,  vb, tc, detss, det1,det2,NbSwap)))
						if(l++ > 10000000) {
							cerr << " Loop in forcing Egde AB" 
								<<"\n vertex A " << a 
								<<"\n vertex B " <<  b 
								<<"\n nb de swap " << NbSwap 
								<<"\n nb of try  swap too big = " <<  l << " gearter than " <<  1000000 << endl;

							if ( CurrentTh ) 
								cerr << " vertex number " << CurrentTh->Number(a) << " " <<  CurrentTh->Number(b) << endl;
							MeshError(990);
						}
					Vertex *aa = tc.EdgeVertex(0), *bb = tc.EdgeVertex(1);
					if (( aa == &a ) && (bb == &b) ||  (bb ==  &a ) && (aa == &b)) {
						tc.SetLock();
						a.Optim(1,0);
						b.Optim(1,0);
						taret = tc;
						return NbSwap;
					}
					else 
					{
						taret = tc;
						return -2; // error  boundary is crossing
					}
				}
				tta = tc;
				assert(k++<2000);
				if ( vbegin == v2 ) return -1;// error 
			}

			tta.SetLock();
			taret=tta;
			a.Optim(1,0);
			b.Optim(1,0);
			return NbSwap; 
		}




		Real8  Vertex::Smoothing(Triangles & Th,const Triangles & BTh,Triangle  * & tstart ,Real8 omega)
		{
			register Vertex * s  = this;
			Vertex &vP = *s,vPsave=vP;
			//  if (vP.on) return 0;// Don't move boundary vertex  

			register Triangle * tbegin= t , *tria = t , *ttc;

			register int k=0,kk=0,j = EdgesVertexTriangle[vint][0],jc;
			R2 P(s->r),PNew(0,0);
			//  cout << BTh.quadtree << " " <<  BTh.quadtree->root << endl;
			// assert(BTh.quadtree && BTh.quadtree->root);
			do {
				k++; 

				if (!tria->Hidden(j))
				{
					Vertex &vQ = (*tria)[VerticesOfTriangularEdge[j][0]]; 

					R2 Q = vQ,QP(P-Q);
					Real8 lQP = LengthInterpole(vP,vQ,QP);
					PNew += Q+QP/Max(lQP,1e-20);
					kk ++;
				}
				ttc =  tria->TriangleAdj(j);
				jc = NextEdge[tria->NuEdgeTriangleAdj(j)];
				tria = ttc;
				j = NextEdge[jc];
				assert(k<2000);
			} while ( tbegin != tria); 
			if (kk<4) return 0;
			PNew = PNew/(Real8)kk;
			R2 Xmove((PNew-P)*omega);
			PNew = P+Xmove;
			Real8 delta=Norme2_2(Xmove); 


			// 
			Icoor2 deta[3];
			I2 IBTh  = BTh.toI2(PNew);

			tstart=BTh.FindTriangleContening(IBTh,deta,tstart);  

			if (tstart->det <0) 
			{ // outside
				double ba,bb;
				TriangleAdjacent edge= CloseBoundaryEdge(IBTh,tstart,ba,bb) ;
				tstart = edge;
				vP.m= Metric(ba,*edge.EdgeVertex(0),bb,*edge.EdgeVertex(1));
			}
			else 
			{ // inside
				Real8   aa[3];
				Real8 s = deta[0]+deta[1]+deta[2];
				aa[0]=deta[0]/s;
				aa[1]=deta[1]/s;
				aa[2]=deta[2]/s;
				vP.m = Metric(aa,(*tstart)[0],(*tstart)[1],(*tstart)[2]);
			}

			// recompute the det of the triangle
			vP.r = PNew;

			vP.i = Th.toI2(PNew);

			Vertex vPnew = vP;

			int ok=1;
			int loop=1;
			k=0;
			while (ok) 
			{
				ok =0;
				do {
					k++; 
					double detold = tria->det;
					tria->det =  bamg::det( (*tria)[0],(*tria)[1]  ,(*tria)[2]);
					if (loop) 
					{
						Vertex *v0,*v1,*v2,*v3;
						if (tria->det<0) ok =1;			       
						else if (tria->Quadrangle(v0,v1,v2,v3))
						{
							vP = vPsave;
							Real8 qold =QuadQuality(*v0,*v1,*v2,*v3);
							vP = vPnew;
							Real8 qnew = QuadQuality(*v0,*v1,*v2,*v3);
							if (qnew<qold) ok = 1;
						}
						else if ( (double)tria->det < detold/2 ) ok=1;

					}
					tria->SetUnMarkUnSwap(0);
					tria->SetUnMarkUnSwap(1);
					tria->SetUnMarkUnSwap(2);
					ttc =  tria->TriangleAdj(j);
					jc = NextEdge[tria->NuEdgeTriangleAdj(j)];
					tria = ttc;
					j = NextEdge[jc];
					assert(k<2000);
				} while ( tbegin != tria); 
				if (ok && loop) vP=vPsave; // no move 
				loop=0;
			}
			return delta;
		}


double QuadQuality(const Vertex & a,const Vertex &b,const Vertex &c,const Vertex &d) {
	// calcul de 4 angles --
	R2 A((R2)a),B((R2)b),C((R2)c),D((R2)d);
	R2 AB(B-A),BC(C-B),CD(D-C),DA(A-D);
	//  Move(A),Line(B),Line(C),Line(D),Line(A);
	const Metric & Ma  = a;
	const Metric & Mb  = b;
	const Metric & Mc  = c;
	const Metric & Md  = d;

	double lAB=Norme2(AB);
	double lBC=Norme2(BC);
	double lCD=Norme2(CD);
	double lDA=Norme2(DA);
	AB /= lAB;  BC /= lBC;  CD /= lCD;  DA /= lDA;
	// version aniso 
	double cosDAB= Ma(DA,AB)/(Ma(DA)*Ma(AB)),sinDAB= Det(DA,AB);
	double cosABC= Mb(AB,BC)/(Mb(AB)*Mb(BC)),sinABC= Det(AB,BC);
	double cosBCD= Mc(BC,CD)/(Mc(BC)*Mc(CD)),sinBCD= Det(BC,CD);
	double cosCDA= Md(CD,DA)/(Md(CD)*Md(DA)),sinCDA= Det(CD,DA);
	double sinmin=Min(Min(sinDAB,sinABC),Min(sinBCD,sinCDA));
	if (sinmin<=0) return sinmin;
	return 1.0-Max(Max(Abs(cosDAB),Abs(cosABC)),Max(Abs(cosBCD),Abs(cosCDA)));
}

}

